﻿@page "/application-detail/{ApplicationDetailModeValue}"
@page "/application-detail/{ApplicationDetailModeValue}/{Id:int}"

<Title>来客申請詳細</Title>
<MudGrid>
    <MudItem md="12">
        <MudCard Class="mb-2">
            <MudCardHeader>
                <MudText Typo="Typo.h6">基本情報</MudText>
            </MudCardHeader>
            <MudCardContent>
                <MudGrid>
                    <MudItem md="12">
                        <MudTextField Label="目的" @bind-Value="application.Purpose"></MudTextField>
                    </MudItem>
                    <MudItem md="3">
                        <MudDatePicker Label="開始日付" @bind-Date="application.FromDatetime"></MudDatePicker>
                    </MudItem>
                    <MudItem md="3">
                        <MudTimePicker Label="開始時刻" @bind-Time="application.FromTime"></MudTimePicker>
                    </MudItem>
                    <MudItem md="3">
                        <MudDatePicker Label="終了日付" @bind-Date="application.ToDatetime"></MudDatePicker>
                    </MudItem>
                    <MudItem md="3">
                        <MudTimePicker Label="終了時刻" @bind-Time="application.ToTime"></MudTimePicker>
                    </MudItem>
                </MudGrid>
            </MudCardContent>
        </MudCard>
    </MudItem>

    <MudItem md="12">
        <MudTabs Elevation="2">
            <MudTabPanel Icon="@Icons.Material.Filled.Mail" Text="宛先">
                <MudCard>
                    <MudCardContent>
                        <MudGrid>
                            <MudItem md="12">
                                <MudGrid>
                                    <MudItem md="5">
                                        <UserSelection @bind-SelectedUser="SelectedUser" />
                                    </MudItem>
                                    <MudItem md="2">
                                        <MudButton Variant="Variant.Filled" Size="Size.Small" Icon="@Icons.Material.Filled.Add" OnClick="AddUser"
                                                   Disabled="!string.IsNullOrEmpty(selectedUserError) || SelectedUser == null">追加</MudButton>
                                    </MudItem>
                                    <MudItem md="5">
                                        @if (!string.IsNullOrEmpty(selectedUserError))
                                        {
                                            <MudText Color="Color.Secondary">@selectedUserError</MudText>
                                        }
                                    </MudItem>
                                </MudGrid>
                            </MudItem>
                            <MudItem md="12">
                                <MudTable Items="users" Dense="true" Hover="true" Striped="true">
                                    <HeaderContent>
                                        <MudTh>フルネーム</MudTh>
                                    </HeaderContent>
                                    <RowTemplate>
                                        <MudTd>@context.FullName</MudTd>
                                    </RowTemplate>
                                </MudTable>
                            </MudItem>
                        </MudGrid>
                    </MudCardContent>
                </MudCard>
            </MudTabPanel>
            <MudTabPanel Icon="@Icons.Material.Filled.Group" Text="来客者">
                <MudCard Class="mb-2">
                    <MudCardContent>
                        <MudGrid>
                            <MudItem md="11">
                                <MudTable Items="application.Visitors" Dense="true" Striped="true" Hover="true" Bordered="true">
                                    <HeaderContent>
                                        <MudTh>@visitorsHeader.GetDisplayName(v => v.CompanyName)</MudTh>
                                        <MudTh>@visitorsHeader.GetDisplayName(v => v.Name)</MudTh>
                                        <MudTh>アクション</MudTh>
                                    </HeaderContent>
                                    <RowTemplate>
                                        <MudTd>@context.CompanyName</MudTd>
                                        <MudTd>@context.Name</MudTd>
                                        <MudTd>
                                            <MudIconButton Size="Size.Small" Color="Color.Secondary"
                                                           Icon="@Icons.Material.Filled.Delete" IconSize="Size.Small"
                                                           @onclick="@(() => application.Visitors.Remove(context))" />
                                        </MudTd>
                                    </RowTemplate>
                                    <RowEditingTemplate>
                                        <MudTd>
                                            <MudTextField Label="@context.GetDisplayName(v => v.CompanyName)" @bind-Value="@context.CompanyName" />
                                            <MudTextField Label="@context.GetDisplayName(v => v.Name)" @bind-Value="@context.Name" />
                                        </MudTd>
                                    </RowEditingTemplate>
                                </MudTable>
                            </MudItem>
                            <MudItem md="1">
                                <MudIconButton Color="Color.Primary" Size="Size.Small"
                                               Icon="@Icons.Material.Filled.Add"
                                               @onclick="@(() => application.Visitors.Add(new()))" />
                            </MudItem>
                            <br />
                            <MudItem md="12">
                                <AttachedFileList AttachedFiles="application.AttachedFiles"
                                                  AttachedFileCategory="AttachedFileCategory.VisitorList" />
                            </MudItem>
                        </MudGrid>
                    </MudCardContent>
                </MudCard>
            </MudTabPanel>
            <MudTabPanel Icon="@Icons.Material.Filled.Schedule" Text="スケジュール">
                <MudCard>
                    <MudCardContent>
                        <MudGrid>
                            <MudItem md="11">
                                <MudTable Items="application.Schedules" Dense="true" Striped="true">
                                    <HeaderContent>
                                        <MudTh>@scheduleHeader.GetDisplayName(s => s.FromDatetime)</MudTh>
                                        <MudTh>@scheduleHeader.GetDisplayName(s => s.ToDatetime)</MudTh>
                                        <MudTh>@scheduleHeader.GetDisplayName(s => s.Overview)</MudTh>
                                        <MudTh>@scheduleHeader.GetDisplayName(s => s.Details)</MudTh>
                                        <MudTh>アクション</MudTh>
                                    </HeaderContent>
                                    <RowTemplate>
                                        <MudTd>@context.FromDatetime</MudTd>
                                        <MudTd>@context.ToDatetime</MudTd>
                                        <MudTd>@context.Overview</MudTd>
                                        <MudTd>@context.Details</MudTd>
                                        <MudTd>
                                            <MudFab Label="削除" Size="Size.Small" Color="Color.Secondary"
                                                    Icon="@Icons.Material.Filled.Delete" IconSize="Size.Small"
                                                    @onclick="@(() => application.Schedules.Remove(context))" />
                                        </MudTd>
                                    </RowTemplate>
                                    <RowEditingTemplate>
                                        <MudTd>
                                            <MudDatePicker Label="@context.GetDisplayName(s => s.FromDatetime)" @bind-Date="@context.FromDatetime" />
                                            <MudTimePicker Label="@context.GetDisplayName(s => s.FromTime)" @bind-Time="@context.FromTime" />
                                            <MudDatePicker Label="@context.GetDisplayName(s => s.ToDatetime)" @bind-Date="@context.ToDatetime" />
                                            <MudTimePicker Label="@context.GetDisplayName(s => s.ToTime)" @bind-Time="@context.ToTime" />
                                            <MudTextField Label="@context.GetDisplayName(s => s.Overview)" @bind-Value="@context.Overview" />
                                            <MudTextField Label="@context.GetDisplayName(s => s.Details)" @bind-Value="@context.Details" />
                                        </MudTd>
                                    </RowEditingTemplate>
                                </MudTable>
                            </MudItem>
                            <MudItem md="1">
                                <MudFab Color="Color.Primary" Size="Size.Small"
                                        Icon="@Icons.Material.Filled.Add"
                                        @onclick="@(() => application.Schedules.Add(new()))" />
                            </MudItem>
                        </MudGrid>
                    </MudCardContent>
                </MudCard>
            </MudTabPanel>
        </MudTabs>
    </MudItem>
</MudGrid>

@if (applicationDetailMode == ApplicationDetailMode.Create || applicationDetailMode == ApplicationDetailMode.Edit)
{
    <MudButton Variant="Variant.Filled" OnClick="SaveTemporarily">一時保存</MudButton>
}

@if (applicationDetailMode == ApplicationDetailMode.Delete)
{
    <MudButton Variant="Variant.Filled" OnClick="Delete">削除</MudButton>
}

<MudButton Variant="Variant.Filled" OnClick="Cancel">キャンセル</MudButton>